## botan3 3.7.1+dfsg

=== src/scripts/ci/cmake_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24)

project(Botan_CMake_Tests CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED On)
set(CMAKE_CXX_EXTENSIONS Off)

if(NOT BOTAN_DISABLED_MODULE)
  message(FATAL_ERROR "Set -DBOTAN_DISABLED_MODULE=??? to define an existing but disabled module for testing.")
endif()

message(STATUS "Assuming that Botan module '${BOTAN_DISABLED_MODULE}' is not available in this build.")

# test #1: find any Botan version and link dynamically
find_package(Botan REQUIRED)
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Test #1 failed: Failed to find Botan with any version")
endif()

if(TARGET Botan::Botan)
  add_executable(botan_version_test main.cpp)
  target_link_libraries(botan_version_test Botan::Botan)

  if(WIN32)
    add_custom_command(TARGET botan_version_test POST_BUILD
                       COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:botan_version_test> $<TARGET_FILE_DIR:botan_version_test>
                       COMMAND_EXPAND_LISTS)
  endif()

  add_test(NAME "Using shared library"
           COMMAND botan_version_test
           PASS_REGULAR_EXPRESSION "${Botan_VERSION}")
endif()

unset(Botan_FOUND)

# test #2: link statically
find_package(Botan REQUIRED)
if(TARGET Botan::Botan-static)
  add_executable(botan_version_test_static main.cpp)
  target_link_libraries(botan_version_test_static Botan::Botan-static)

  add_test(NAME "Using static library"
           COMMAND botan_version_test_static
           PASS_REGULAR_EXPRESSION "${Botan_VERSION}")
endif()

unset(Botan_FOUND)

# test #3: find Botan version installed by version number
find_package(Botan ${Botan_VERSION} REQUIRED)
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Failed to find Botan with version ${Botan_VERSION}")
endif()

unset(Botan_FOUND)

# test #4: find Botan with specific modules
find_package(Botan ${Botan_VERSION} COMPONENTS ecdsa rsa REQUIRED)
if(NOT Botan_ecdsa_FOUND OR NOT Botan_rsa_FOUND)
  message(FATAL_ERROR "Package did not specify that the (optional) components were found: ecdsa, rsa")
endif()

if(NOT Botan_FOUND)
  message(FATAL_ERROR "Failed to find Botan with version ${Botan_VERSION} containing modules: ecdsa, rsa")
endif()

unset(Botan_FOUND)

# test #5: fail if required module is not included
find_package(Botan ${Botan_VERSION} COMPONENTS ${BOTAN_DISABLED_MODULE} QUIET)
if(Botan_FOUND)
  message(FATAL_ERROR "Found Botan with version ${Botan_VERSION}: Found module ${BOTAN_DISABLED_MODULE} but expected it to be absent")
endif()

unset(Botan_FOUND)

# test #6: do not fail if optional module is not included
find_package(Botan ${Botan_VERSION} OPTIONAL_COMPONENTS ${BOTAN_DISABLED_MODULE} REQUIRED)
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Failed to find Botan with version ${Botan_VERSION}, despite missing optional modules: ${BOTAN_DISABLED_MODULE}")
endif()
if(NOT DEFINED Botan_${BOTAN_DISABLED_MODULE}_FOUND OR ${Botan_${BOTAN_DISABLED_MODULE}_FOUND})
  message(FATAL_ERROR "Failed to notify that the optional component was not found")
endif()

unset(Botan_FOUND)

# test #7: fail with some specific (but unavailable) component and fall-back to generic
find_package(Botan ${Botan_VERSION} COMPONENTS nonexistent unobtainium QUIET)
if(NOT Botan_FOUND)
  # try again without requiring specific components
  find_package(Botan ${Botan_VERSION})
else()
  message(FATAL_ERROR "Found Botan regardless of the non-existent component requirement")
endif()
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Failed to find generic Botan as a second attempt")
endif()

unset(Botan_FOUND)

# test #8: try to find a future version
math(EXPR Botan_FUTURE_MAJOR_VERSION "${Botan_VERSION_MAJOR} + 1")
find_package(Botan ${Botan_FUTURE_MAJOR_VERSION} QUIET)
if(Botan_FOUND)
  message(FATAL_ERROR "Found a future major version that doesn't exist yet: ${Botan_FUTURE_MAJOR_VERSION}")
endif()

unset(Botan_FOUND)

# test #9: try to find an older version (that is not compatible with the installed one)
math(EXPR Botan_PAST_MAJOR_VERSION "${Botan_VERSION_MAJOR} - 1")
find_package(Botan ${Botan_PAST_MAJOR_VERSION} QUIET)
if(Botan_FOUND)
  message(FATAL_ERROR "Found a legacy major version that doesn't exist yet: ${Botan_PAST_MAJOR_VERSION}")
endif()

unset(Botan_FOUND)

# test #10: try to find Botan with a different case-sensitive spelling
find_package(botan COMPONENTS rsa REQUIRED)
if(NOT botan_FOUND)
  message(FATAL_ERROR "Failed to find Botan with a different case-spelling")
endif()
if(NOT botan_rsa_FOUND)
  message(FATAL_ERROR "Failed to find Botan component with a different case-spelling")
endif()

unset(Botan_FOUND)
unset(botan_FOUND)

enable_testing()

=== debian/changelog ===
botan3 (3.7.1+dfsg-2) unstable; urgency=medium

  * Build depend on ca-certificates.
  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 22 Mar 2025 16:53:54 +0100

botan3 (3.7.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Make botan library depend on ca-certificates.
  * Library transition from libbotan-3-6 to libbotan-3-7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 07 Mar 2025 12:57:39 +0100

botan3 (3.6.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-5 to libbotan-3-6 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 13 Nov 2024 17:40:11 +0100

botan3 (3.5.0+dfsg-1) experimental; urgency=medium

  * New upstream release:
    - fixes CVE-2024-34702: Denial of Service Due to Excessive Name
      Constraints,
    - fixes CVE-2024-39312: Authorization Error due to Name Constraint
      Decoding Bug.
  * Library transition from libbotan-3-4 to libbotan-3-5 .
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 14 Jul 2024 11:24:20 +0200

botan3 (3.4.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-3 to libbotan-3-4 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 12 Apr 2024 19:37:09 +0200

botan3 (3.3.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-2 to libbotan-3-3 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 23 Feb 2024 22:36:42 +0100

botan3 (3.2.0+dfsg-1) experimental; urgency=medium

  * Initial upload (closes: #1055762).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 10 Nov 2023 20:04:33 +0100

=== debian/control ===
Source: botan3
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ca-certificates,
 dh-python,
 libbz2-dev,
 liblzma-dev,
 libsqlite3-dev,
 libtspi-dev,
 zlib1g-dev,
 python3:any,
 python3-docutils,
 ca-certificates,
Build-Depends-Indep:
 python3-sphinx,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://botan.randombit.net/

Package: botan
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: botan (<< 3-1~)
Replaces: botan (<< 3-1~)
Description: multiplatform crypto library (3.x version)
 Botan is a C++ library which provides support for many common cryptographic
 operations, including encryption, authentication, and X.509v3 certificates and
 CRLs. A wide variety of algorithms is supported, including RSA, DSA, DES, AES,
 MD5, and SHA-1.
 .
 This package contains the 3.x version of Botan.

Package: libbotan-3-7
Section: libs
Architecture: any
Multi-Arch: same
Depends: ca-certificates, ${misc:Depends}, ${shlibs:Depends}
Description: multiplatform crypto library (3.x version)
 Botan is a C++ library which provides support for many common cryptographic
 operations, including encryption, authentication, and X.509v3 certificates and
 CRLs. A wide variety of algorithms is supported, including RSA, DSA, DES, AES,
 MD5, and SHA-1.
 .
 This package contains the 3.x version of Botan.

Package: libbotan-3-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libbotan-3-7 (= ${binary:Version})
Description: multiplatform crypto library (3.x version)
 Botan is a C++ library which provides support for many common cryptographic
 operations, including encryption, authentication, and X.509v3 certificates and
 CRLs. A wide variety of algorithms is supported, including RSA, DSA, DES, AES,
 MD5, and SHA-1.
 .
 This package contains the 3.x version of Botan.

Package: libbotan-3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, sphinx-doc
Description: multiplatform crypto library (3.x version)
 Botan is a C++ library which provides support for many common cryptographic
 operations, including encryption, authentication, and X.509v3 certificates and
 CRLs. A wide variety of algorithms is supported, including RSA, DSA, DES, AES,
 MD5, and SHA-1.
 .
 This package contains the 3.x version of Botan.

Package: python3-botan
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-7 (= ${binary:Version})
Breaks: python3-botan (<< 3-1~)
Replaces: python3-botan (<< 3-1~)
Description: multiplatform crypto library (3.x version), Python3 module
 Botan is a C++ library which provides support for many common cryptographic
 operations, including encryption, authentication, and X.509v3 certificates and
 CRLs. A wide variety of algorithms is supported, including RSA, DSA, DES, AES,
 MD5, and SHA-1.
 .
 This package contains the Botan (3.x version) module for Python 3.x .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk

DEVPKG = $(CURDIR)/debian/libbotan-3-dev
DOCPKG = $(CURDIR)/debian/libbotan-3-doc

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
OS_MAP_hurd = gnu
OS_MAP_kfreebsd = gnu/kfreebsd
CROSS_FLAGS += --os=$(or $(OS_MAP_$(DEB_HOST_ARCH_OS)),$(DEB_HOST_ARCH_OS))
CPU_MAP_aarch64 = arm64
CPU_MAP_arm = arm32
CPU_MAP_i686 = x86_32
CPU_MAP_mips64el = mips64
CPU_MAP_mips = mips32
CPU_MAP_mipsel = mips32
CPU_MAP_powerpc = ppc32
CPU_MAP_powerp64 = ppc64
CPU_MAP_powerpc64le = ppc64
CPU_MAP_sh4 = superh
ifeq (,$(filter $(DEB_HOST_ARCH),armhf hurd-i386))
CROSS_FLAGS +=--cpu=$(or $(CPU_MAP_$(DEB_HOST_GNU_CPU)),$(DEB_HOST_GNU_CPU))
endif
CROSS_FLAGS += --cc-bin=$(CXX) --ar-command=$(AR)
endif

override_dh_clean:
	dh_clean
	rm -f $(CURDIR)/Certificate\ Store*.db

override_dh_auto_configure:
	$(CURDIR)/configure.py \
		$(CROSS_FLAGS) \
		--prefix=/usr/ \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		$(if $(filter $(DEB_HOST_ARCH), armel armhf),--disable-neon) \
		--with-rst2man \
		--with-bzip2 \
		--with-lzma \
		--with-sqlite3 \
		--with-tpm \
		--with-zlib \
		--with-python-versions=3 \
		$(if $(filter $(DEB_HOST_ARCH), armhf),--cpu=armv7) \
		$(if $(filter $(DEB_HOST_ARCH), hurd-i386),--cpu=x86_32) \
		--distribution-info=$(shell dpkg-vendor --query Vendor)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=. $(CURDIR)/botan-test
endif

override_dh_install-arch:
	dh_install -a
	sed -i -e 's/ -f\(debug\|file\)-prefix-map=[^ ]*=\. / /' $(DEVPKG)/usr/include/botan-3/botan/build.h

override_dh_install-indep:
	dh_install -i
	rm -rf $(DOCPKG)/usr/share/doc/libbotan-3-doc/handbook/.doctrees

%:
	dh $@ --with python3

.PHONY: override_dh_clean override_dh_auto_configure override_dh_auto_test \
	override_dh_install-arch override_dh_install-indep

## botan3 3.8.1+dfsg

=== debian/changelog ===
botan3 (3.8.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-7 to libbotan-3-8 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 14 May 2025 18:23:23 +0200

=== debian/control ===
--- 
+++ 
@@ -34,7 +34,7 @@
  .
  This package contains the 3.x version of Botan.
 
-Package: libbotan-3-7
+Package: libbotan-3-8
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -50,7 +50,7 @@
 Package: libbotan-3-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libbotan-3-7 (= ${binary:Version})
+Depends: ${misc:Depends}, libbotan-3-8 (= ${binary:Version})
 Description: multiplatform crypto library (3.x version)
  Botan is a C++ library which provides support for many common cryptographic
  operations, including encryption, authentication, and X.509v3 certificates and
@@ -75,7 +75,7 @@
 Package: python3-botan
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-7 (= ${binary:Version})
+Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-8 (= ${binary:Version})
 Breaks: python3-botan (<< 3-1~)
 Replaces: python3-botan (<< 3-1~)
 Description: multiplatform crypto library (3.x version), Python3 module

## botan3 3.9.0+dfsg

=== src/scripts/ci/cmake_tests/CMakeLists.txt ===
--- 
+++ 
@@ -18,9 +18,9 @@
   message(FATAL_ERROR "Test #1 failed: Failed to find Botan with any version")
 endif()
 
-if(TARGET Botan::Botan)
+if(TARGET botan::botan)
   add_executable(botan_version_test main.cpp)
-  target_link_libraries(botan_version_test Botan::Botan)
+  target_link_libraries(botan_version_test botan::botan)
 
   if(WIN32)
     add_custom_command(TARGET botan_version_test POST_BUILD
@@ -37,9 +37,9 @@
 
 # test #2: link statically
 find_package(Botan REQUIRED)
-if(TARGET Botan::Botan-static)
+if(TARGET botan::botan-static)
   add_executable(botan_version_test_static main.cpp)
-  target_link_libraries(botan_version_test_static Botan::Botan-static)
+  target_link_libraries(botan_version_test_static botan::botan-static)
 
   add_test(NAME "Using static library"
            COMMAND botan_version_test_static

=== debian/changelog ===
botan3 (3.9.0+dfsg-2.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Let libbotan-3-dev depend on the dev packages that are in its pkgconf.
    (closes: #1114813)

 -- Bastian Germann <bage@debian.org>  Thu, 11 Sep 2025 17:57:35 +0200

botan3 (3.9.0+dfsg-2) experimental; urgency=medium

  * Do not try to disable NEON on armel and armhf, it's not needed anymore.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 20 Aug 2025 16:57:51 +0200

botan3 (3.9.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-8 to libbotan-3-9 .
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 16 Aug 2025 15:01:29 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  ca-certificates,
 Build-Depends-Indep:
  python3-sphinx,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://botan.randombit.net/
 
@@ -34,7 +34,7 @@
  .
  This package contains the 3.x version of Botan.
 
-Package: libbotan-3-8
+Package: libbotan-3-9
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -50,7 +50,12 @@
 Package: libbotan-3-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libbotan-3-8 (= ${binary:Version})
+Depends: ${misc:Depends}, libbotan-3-9 (= ${binary:Version}),
+ libbz2-dev,
+ liblzma-dev,
+ libsqlite3-dev,
+ libtspi-dev,
+ zlib1g-dev,
 Description: multiplatform crypto library (3.x version)
  Botan is a C++ library which provides support for many common cryptographic
  operations, including encryption, authentication, and X.509v3 certificates and
@@ -75,7 +80,7 @@
 Package: python3-botan
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-8 (= ${binary:Version})
+Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-9 (= ${binary:Version})
 Breaks: python3-botan (<< 3-1~)
 Replaces: python3-botan (<< 3-1~)
 Description: multiplatform crypto library (3.x version), Python3 module

=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,6 @@
 		$(CROSS_FLAGS) \
 		--prefix=/usr/ \
 		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
-		$(if $(filter $(DEB_HOST_ARCH), armel armhf),--disable-neon) \
 		--with-rst2man \
 		--with-bzip2 \
 		--with-lzma \

=== debian/watch ===
version=4
# GitHub
opts=uversionmangle=s/(\d)[_\.\-\+]?((rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/i,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i,\
pgpsigurlmangle=s/$/.asc/ \
https://github.com/randombit/botan/tags \
(?:|.*/)v?(3.\d\S*)@ARCHIVE_EXT@

# Upstream
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
uversionmangle=s/-?(beta)-?/~$1/;s/-?(alpha)-?/~$1/;s/-?(rc)-?/~rc/;s/\.?(RC)-?/~rc/,\
pgpsigurlmangle=s/$/.asc/ \
https://botan.randombit.net/releases/ Botan-(3.\d\S+)@ARCHIVE_EXT@

## botan3 3.10.0%2Bdfsg

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i
Owner: randombit
Project: botan
Pgpsigurlmangle: s/$/.asc/

## botan3 3.10.0+dfsg

=== src/scripts/ci/cmake_tests/CMakeLists.txt ===
--- 
+++ 
@@ -131,4 +131,15 @@
 unset(Botan_FOUND)
 unset(botan_FOUND)
 
+# test #11: use backward-compatibility ALIAS targets
+#           (Assuming that we use at least CMake 3.18, otherwise that might fail)
+find_package(Botan REQUIRED)
+if(Botan_FOUND)
+  if(NOT TARGET Botan::Botan AND NOT TARGET Botan::Botan-static)
+    message(FATAL_ERROR "Test #11 didn't find the expected backward-compatibility ALIAS target")
+  endif()
+endif()
+
+unset(Botan_FOUND)
+
 enable_testing()

=== debian/changelog ===
botan3 (3.10.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libbotan-3-9 to libbotan-3-10 .
  * Remove now redundant Rules-Requires-Root value.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 07 Nov 2025 17:22:38 +0100

=== debian/control ===
--- 
+++ 
@@ -13,11 +13,9 @@
  zlib1g-dev,
  python3:any,
  python3-docutils,
- ca-certificates,
 Build-Depends-Indep:
  python3-sphinx,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://botan.randombit.net/
 
 Package: botan
@@ -34,7 +32,7 @@
  .
  This package contains the 3.x version of Botan.
 
-Package: libbotan-3-9
+Package: libbotan-3-10
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -50,7 +48,7 @@
 Package: libbotan-3-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libbotan-3-9 (= ${binary:Version}),
+Depends: ${misc:Depends}, libbotan-3-10 (= ${binary:Version}),
  libbz2-dev,
  liblzma-dev,
  libsqlite3-dev,
@@ -80,7 +78,7 @@
 Package: python3-botan
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-9 (= ${binary:Version})
+Depends: ${misc:Depends}, ${python3:Depends}, libbotan-3-10 (= ${binary:Version})
 Breaks: python3-botan (<< 3-1~)
 Replaces: python3-botan (<< 3-1~)
 Description: multiplatform crypto library (3.x version), Python3 module
